#ifndef _USchEditor_USchEditor_h
#define _USchEditor_USchEditor_h

#include <CtrlLib/CtrlLib.h>


#include "model.h"

using namespace Upp;

#define LAYOUTFILE <USchEditor/USchEditor.lay>
#include <CtrlCore/lay.h>

#define LLOG RLOG





class USchEditor : public WithUSchEditorLayout<TopWindow> {
public:
	typedef USchEditor CLASSNAME;
	USchEditor();
	
	EditStringNotNull editTableName;
	EditStringNotNull editColumnName;
	EditInt editLength;
	DropList editType;
	DropList editRef;
	ArrayOption ai, pk, nn;
	ArrayOption option;
	
	bool newline;
	
	Database db;
	
	Table* selected_table;

	bool TablesAcceptRow();
	void TablesUpdateRow();
	void TablesSel();
	void ColumnsSel();
	bool ColumnsAcceptRow();
	void ColumnsCtrlsAction();
	void ColumnsStartEdit();
	void ColumnsAcceptEdit();
	void ColumnsUpdateRow();
	
	void UpdateObjects();
	void UpdateView();
	void LoadDropDownRef();
	
	virtual bool Accept();
	
	void FromClip()
	{
		String str = ReadClipboardText();
		LoadFromString(str);
	}
	
	void FromFile()
	{
		
		String str = SelectLoadFile("sch file\t*.sch");
		LoadFromString(str);
	}
	
	void ToClip()
	{
		String s = SaveToString();
		WriteClipboardText(s);
	}
	
	void ToFile()
	{
		String s = SaveToString();
		SelectSaveFile("sch file\t*.sch", s);	
	}
	
	void LoadFromString(String& str)
	{
		if(!append) db.tables.Clear();

		LoadSchFromString(str, db);
		gen_ids = db.genId;
		UpdateView();
	}
	
	String SaveToString()
	{
		return SaveSchToString(db, gen_ids);
	}	
};

#endif
