#ifndef _USchEditor_model_h_
#define _USchEditor_model_h_



using namespace Upp;

struct Column
{
	String name;
	bool genId;
	
	String type;
	bool auto_increment;
	bool not_null;
	bool in_primarykey;
	String referance;
	int length;
	
	Value defaultvalue;
	
	Column()
	{
		referance = "";
		length = 0;
		name = "";
		type = "";
		defaultvalue = 0;
		
		genId = auto_increment = not_null = in_primarykey = false;
	}
};

struct Database;

struct Table
{
	String name;
	bool genId;
	
	Database* pdb;
	
	ArrayMap<String, Column> columns;
	
	Column& AddColumn(String name)
	{
		Column& c = columns.Add(name);
		c.name = name;
		
		return c;
	}
	
	Table():pdb(NULL){}
};

struct Database
{
	ArrayMap<String, Table> tables;
	
	bool genId;
	
	Table& AddTable(String name)
	{
		Table& t = tables.Add(name);
		t.name = name;
		t.pdb = this;
		
		return t;
	}
};


void LoadSchFromString(String& str, Database& db);
String SaveSchToString(Database& db, bool gen_ids);

#endif
